#pragma once

#include "Vista.hpp"
#include "tsne.h"

class Vistaplus : public Vista
{
public:
	Vistaplus(corpus* corp, int K, int KK, int L, double lambda, double lambda2) 
			: Vista(corp, K, KK, L, lambda)
			, lambda2(lambda2) {}

	~Vistaplus() {}
	
	void init();
	void cleanUp();

	void getParametersFromVector(	double*   g,
									double**  decay_a,
									double**  decay_b,
									double**  decay_user_a,
									double**  decay_user_b,
									double*** gamma_user, 
									double*** gamma_item,
									double*** kappa_user,
									double*** kappa_item,
									double*** E,
									double*** Ep,
									action_t  action);

	void projectX(int x);
	void project();

	double prediction(int user, int prev_item, int item) { return -1; }
	double prediction(int user, vector<int>& prev_items, int item);

	void updateFactors(int user_id, vector<int>& prev_items, int pos_item_id, int neg_item_id, double learn_rate);
	string toString();
	
	void sampleAUC(double* AUC_val, double* AUC_test, double* var);
	void AUC(double* AUC_val, double* AUC_test, double* var);
	void AUC_coldItem(double* AUC_test, double* var, int* num_user);
	void AUC_coldUser(double* AUC_test, double* var, int* num_user);
	void AUC_coldUserItem(double* AUC_test, double* var, int* num_user);
	void AUC_coldFull(double* AUC_test, double* var, int* num_user);
	
	void AUC_OwnerTransition(double* AUC_test, double* var, int* num_user);
	void AUC_NonOwnerTransition(double* AUC_test, double* var, int* num_user);
	void AUC_SessionTransition(double* AUC_test, double* var, int* num_user);
	void AUC_NonSessionTransition(double* AUC_test, double* var, int* num_user);

	void tsne2D(const char* tofilePath);

	/* variables */
	double** E;
	double** Ep;

	double** theta_item;
	double** kappaV_item;

	/* hyper-parameters */
	double lambda2;
};
